package eu.chorevolution.cd.utility.sia.endpoints.manager.services;
		
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;

import eu.chorevolution.cd.utility.sia.endpoints.manager.baseservice.SetInvocationAddress;
import eu.chorevolution.cd.utility.sia.endpoints.manager.baseservice.SetInvocationAddressResponse;
import eu.chorevolution.cd.utility.sia.endpoints.manager.util.SetInvocationAddressUtils;
import eu.chorevolution.cd.utility.sia.endpoints.manager.util.Utils;
import net.sf.saxon.dom.NodeWrapper;

public class SiaEndpointsManagerService {
	
	private static Logger LOGGER = LoggerFactory.getLogger(SiaEndpointsManagerService.class);
	
	public static Document storeParticipantAddress(String participantFromName, NodeWrapper setInvocationAddressNodeWrapper){
		
		LOGGER.info("CALLED storeParticipantAddress ON Sia Endpoints Manager");		
		SetInvocationAddress setInvocationAddress = (SetInvocationAddress) Utils.unmarshallNodeWrapperToObject(setInvocationAddressNodeWrapper, SetInvocationAddress.class);
		SetInvocationAddressUtils.storeParticipantArtifactEndpointData(participantFromName, setInvocationAddress.getArg0(), setInvocationAddress.getArg1(), setInvocationAddress.getArg2());
		return Utils.createDocumentFromObject(new SetInvocationAddressResponse());
	}
	
	
	public static String getParticipantAddress(String participantFromName, String participantToRoleName, String participantToAddress){
		
		LOGGER.info("CALLED getParticipantAddress ON Sia Endpoints Manager");			
		String participantAddressRetrieved = SetInvocationAddressUtils.getParticipantArtifactEndpointAddressFromRole(participantFromName, participantToRoleName);
		return participantAddressRetrieved != null ? participantAddressRetrieved:participantToAddress;
	}	
			
}
